import Hero, { ISuperElement } from "@ulixee/hero";
import { Api } from "telegram";
import { sleep } from "telegram/Helpers";
import { settings } from "../Databases/JSONDatabase";
import { timeout, TimeoutError, UnknownError } from "../Helpers/utils";
import { TelegramWorker } from "../Worker/TelegramWorker";
import { CaptchaError } from "./Errors";

export async function doSiteTasks(telegramWorker: TelegramWorker,earnMSG: Api.Message,hero: Hero) {
    let task: Api.Message=earnMSG;
    while (true){
        await earnMSG.buttons![1][0].click({sharePhone: false});
        try{
            task=(await telegramWorker.waitForNewMessages(earnMSG.sender!,task.id,settings.botMessages.siteTask,10_000))[0];
        }catch{
            try{
                await telegramWorker.waitForNewMessages(earnMSG.sender!,task.id,settings.botMessages.taskOver,10_000);
            } catch{
                // unknown state
                throw new UnknownError("Unknown state of message due doing site tasks")
            } finally{
                console.log(`${telegramWorker.worker.phoneNumber}: All site tasks are completed`)
                return
            }
           
        }
        
        const skipButton=task.buttons![0][1];
        const link=task.buttons![0][0].url;
        if (link!==undefined){
            
            for (let tries=0;tries<3+1;tries++){
                if (tries===3){
                    console.log(`${telegramWorker.worker.phoneNumber}:Some error while going to link`);
                    return
                }
                try{
                    await hero.goto(link, { timeoutMs: 120_000 });
                } catch (err){
                    continue
                } finally {
                    break
                }
            }
            
            try {
                await hero.waitForLoad("AllContentLoaded", { timeoutMs: 120_000 });
            } catch (err) {
                continue
            }
            try{
                await timeout(
                    (async ()=>{
                        while (await hero.querySelector("button.g-recaptcha.btn.btn-primary") !== null) {
                            let isCaptchaVisible = false;
                            try {
                                isCaptchaVisible = await hero.querySelector("input[id='recaptcha-token']").$isVisible
                            } catch (err) {
                                continue
                            }
                            if (isCaptchaVisible === false) {
                                let captchaButton: ISuperElement;
                                try {
                                    captchaButton = await hero.querySelector("button.g-recaptcha.btn.btn-primary").$waitForExists();
                                } catch {
                                    // throw new UnknownError("There is no any captcha button")
                                    // await skipButton.click({sharePhone: false});
                                    continue
                                }
                                if (await captchaButton.$isClickable){
                                    try{
                                        await hero.interact({ move: captchaButton }, {
                                            click: {
                                                element: captchaButton,
                                                verification: "exactElement",
                                            },
                                        });
                                    } catch{
                                        continue
                                    } finally{
                                        await sleep(5000);
                                    }
                                } else {
                                    
                                        
                                    if (settings.bypassMode && await hero.querySelector("#form")!==null){
                                        try {
                                            await hero.executeJs(
                                                "document.getElementById('form').setAttribute('style', '')"
                                            );
                                        } catch (err) {
                                            console.log(`Something went wrong due bypass`,err);
                                        }
                                         continue
                                    }
                                    await sleep(1_000);
                                }
                            } else {
                                throw new CaptchaError("Captcha detected");
                            }
                        }
                    })(),
                    180_000
                )
            } catch (err){
                if (!(err instanceof TimeoutError)){
                    throw err
                } else {
                    console.log(`${telegramWorker.worker.phoneNumber}:Skipping site task due Timeout`)
                    await skipButton.click({sharePhone: false});
                }
            }
            
            

        } else {
            console.log('Something strange due doing site tasks\n',link,task.message)
            return
        }

    }
}