import Hero, { ISuperElement } from "@ulixee/hero";
import { sleep } from "telegram/Helpers";
import { UnknownError } from "../Helpers/utils";
import { IWorker } from "../Worker/IWorker";
import { CaptchaError } from "./Errors";


export async function verification(link: string, hero: Hero) {
    for (let tries=0;tries<3+1;tries++){
        if (tries===3){
            console.log(`Some error while going to link`);
            return
        }
        try{
            await hero.goto(link, { timeoutMs: 120_000 });
        } catch (err){
            continue
        } finally {
            break
        }
    }
    try {
        await hero.waitForLoad("AllContentLoaded", { timeoutMs: 120_000 });
    } catch (err) {
        return
    }
    while (await hero.querySelector("button.g-recaptcha.btn.btn-primary") !== null) {
        

        let isCaptchaVisible = false;
        try {
            isCaptchaVisible = await hero.querySelector("input[id='recaptcha-token']").$isVisible
        } catch (err) {
            continue
        }
        if (isCaptchaVisible === false) {
            let captchaButton: ISuperElement;
            try {
                captchaButton = await hero.querySelector("button.g-recaptcha.btn.btn-primary").$waitForExists();
            } catch {
                throw new UnknownError("There is no any captcha button")
            }
            try{
                await hero.interact({ move: captchaButton }, {
                    click: {
                        element: captchaButton,
                        verification: "exactElement",
                    },
                });
            } catch{
                continue
            } finally{
                await sleep(5000);
            }
        } else {
            throw new CaptchaError("Captcha detected");
        }
    }

    if (await hero.querySelector("body > section > h2") !== null && (await hero.querySelector("body > section > h2").textContent) === 'All right!') {
        return
    } else {
        try {
            console.log(await hero.querySelector("body > section > h2").textContent)
        } catch {
            throw new UnknownError("Strange text:" + await hero.document.body.textContent)
        }
        throw new UnknownError("Something strange with text of h2")
    }
}