import { Fingerprint } from "fingerprint-generator"
import { IFaucetMail } from "../Databases/IFaucetMail"

export interface IRawWorker {
    readonly phoneNumber: string,
    readonly telegramID: number,
    readonly apiID: number,
    readonly apiHash: string,
    readonly password: string,
    readonly faucetMail: string,
    readonly stringSession: string,
    balance: number,
    readonly canBeRefferal: boolean,
    readonly browserFingerprint: string,
    readonly refferal: number | null,
    readonly isMailed: number,
    troubled: number,
    
}

export interface IWorker extends Omit<IRawWorker, "faucetMail" | "browserFingerprint" | "isMailed" | "troubled"> {
    readonly faucetMail: IFaucetMail,
    readonly browserFingerprint: Fingerprint,
    readonly isMailed: boolean,
    troubled: boolean,
}

