import { startsWith } from "lodash";
import { db } from "../Databases/SQLDatabase";
import { wrappedContainer } from "../DockerWrapper/Docker";
import { DockerContainerIsBroken } from "../DockerWrapper/DockerErrors";
import { IWorker } from "./IWorker";
interface usedIP {
    ips: string[],
    worker: Pick<IWorker, "phoneNumber">
}

export class WorkerController {
    availableWorkers: IWorker[] = [];
    protected isLoaded = false;
    protected usedIPs: usedIP[] = [];
    async load(_db = db) {
        if (this.availableWorkers.length === 0 || this.isLoaded === false) {
            this.availableWorkers = await _db.getWorkers();
            this.isLoaded = true;
        }
    }
    push_back(worker:IWorker){ // maybe need to make it async
        const isExists=this.availableWorkers.filter((_worker)=>{
            return _worker.phoneNumber===worker.phoneNumber
        }).length >0 ? true : false;
        if (isExists===false){
            this.availableWorkers.push(worker);
        }
    }
    removeLastIP(worker:Pick<IWorker,"phoneNumber">){
        this.usedIPs.filter((usedIP) => {
            return usedIP.worker.phoneNumber===worker.phoneNumber
        }).pop()
    }
    async* interateWorkers(container: wrappedContainer) {
        if (this.isLoaded) {
            if (container.getHealthStatus() == "healthy") {
                const worker=this.availableWorkers.pop();
                if (worker!==undefined && worker.troubled===false){
                    yield worker
                }
            } 
            // else {
            //     throw new DockerContainerIsBroken("unhealthy");
            // }
        } else {
            throw new Error("Iterator is not loaded");
        }
    }
    isFreeIP(worker: Pick<IWorker, "phoneNumber">, ip: string) {
        const isUnique=this.usedIPs.filter((usedIP) => {
            return usedIP.worker.phoneNumber!==worker.phoneNumber && usedIP.ips.filter((value) => startsWith(value, ip) === true).length !== 0
        });
        if (isUnique.length === 0) {
            const usedIP=this.usedIPs.filter((usedIP) => {
                return usedIP.worker.phoneNumber == worker.phoneNumber
            })
            if (usedIP.length===0){
                this.usedIPs.push({
                    worker:worker,
                    ips:[ip]
                })
            } else {
                usedIP[0].ips.push(ip);
            }
            return true
        } else {
            return false
        }

    }
}